/* ###################################################################
**     This component module is generated by Processor Expert. Do not modify it.
**     Filename    : COPFree.c
**     Project     : example_9
**     Processor   : MC9S08SE8CWL
**     Component   : Init_COP
**     Version     : Component 01.056, Driver 01.14, CPU db: 3.00.015
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-11-03, 00:00, # CodeGen: 1
**     Abstract    :
**          This file implements the Computer Operating Properly (COPFree)
**          module initialization according to the Peripheral 
**          Initialization Component settings, and defines interrupt service 
**          routines prototypes.
**          The computer operating properly (COP) module contains a free-running 
**          counter that generates a reset if allowed to overflow. The COP module
**          helps software recover from runaway code. Prevent a COP reset by 
**          clearing the COP counter periodically.
**     Settings    :
**          Component name                                 : COPFree
**          Device                                         : COPFree
**          Settings 
**            Clock setting 
**              Clock select                               : Internal clock
**              Time-out period prescaler                  : 1024 cycles
**              Time-out period                            : 1024 ms
**            Mode                                         : Normal
**          Initialization 
**            Call Init method                             : yes
**            Enable COP                                   : no
**     Contents    :
**         Init - void COPFree_Init(void);
**
**     Copyright : 1997 - 2014 Freescale Semiconductor, Inc. 
**     All Rights Reserved.
**     
**     Redistribution and use in source and binary forms, with or without modification,
**     are permitted provided that the following conditions are met:
**     
**     o Redistributions of source code must retain the above copyright notice, this list
**       of conditions and the following disclaimer.
**     
**     o Redistributions in binary form must reproduce the above copyright notice, this
**       list of conditions and the following disclaimer in the documentation and/or
**       other materials provided with the distribution.
**     
**     o Neither the name of Freescale Semiconductor, Inc. nor the names of its
**       contributors may be used to endorse or promote products derived from this
**       software without specific prior written permission.
**     
**     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
**     ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
**     WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
**     DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
**     ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
**     (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
**     LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
**     ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
**     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
**     SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
**     
**     http: www.freescale.com
**     mail: support@freescale.com
** ###################################################################*/
/*!
** @file COPFree.c
** @version 01.14
** @brief
**          This file implements the Computer Operating Properly (COPFree)
**          module initialization according to the Peripheral 
**          Initialization Component settings, and defines interrupt service 
**          routines prototypes.
**          The computer operating properly (COP) module contains a free-running 
**          counter that generates a reset if allowed to overflow. The COP module
**          helps software recover from runaway code. Prevent a COP reset by 
**          clearing the COP counter periodically.
*/         
/*!
**  @addtogroup COPFree_module COPFree module documentation
**  @{
*/         
/* MODULE COPFree. */
#include "COPFree.h"

/*
** ===================================================================
**     Method      :  COPFree_Init (component Init_COP)
**     Description :
**         This method initializes registers of the COP module
**         according to this Peripheral Initialization Component settings.
**         Call this method in the user code to initialize the
**         module. By default, the method is called by PE
**         automatically; see "Call Init method" property of the
**         component for more details.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
void COPFree_Init(void)
{
  setReg8(SRS, 0x55U);                 /* Clear WatchDog counter - first part */ 
  setReg8(SRS, 0xAAU);                 /* Clear WatchDog counter - second part */ 
}

/* END COPFree. */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
