/* ###################################################################
**     Filename    : main.c
**     Project     : example_9
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-11-02, 23:58, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */
//Code for the TX. 

/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */

void UART_Init(void) {
	SCIBDH=0x00;
	SCIBDL=0x52;//Baud rate = clock speed/(16*prescaler)=8MHz/(16*52)=9615.3846
	SCIC1=0x00;
	SCIC2=0x0C;
}
	
void ADC_Init(void){ //ADC channel 0. If you want to change the channel => ADCSC1=0x20+n, n<=9
	
	ADCCFG=0x71;
	ADCSC2_ADTRG=0;
    ADCSC2_ACFE=0;
	ADCSC2_ACFGT=0;
	ADCSC1=0x20;
}

char ADC_Read(void)
{   
    while(ADCSC1_COCO==0);
    return (ADCRL); //ADC resolution = 8 bits
}


void main(void)
{
  /* Write your local variable definition here */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  /* For example: for(;;) { } */
  COPFree_Init();
  UART_Init();
  ADC_Init();
  
    for(;;) {
    	if(SCIS1_TDRE==1)SCID=ADC_Read();
    	Cpu_Delay100US(3000);
    }
 
  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
